library IEEE;
library UNISIM;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity count2Z is
	port (
		clk : in std_logic ;
		rst : in std_logic ;
		en : in std_logic ;
		sclr : in std_logic ;
		s : out std_logic_vector (1 downto 0) ;
		ripple : out std_logic
	);
end count2Z;

architecture synthesis of count2Z is

	-- buffer signals declarations
	signal s_int : std_logic_vector (1 downto 0) ;

	-- internal signals declarations
	signal ts : std_logic_vector (1 downto 0) ;

begin

	-- buffer signals assignations
	s(1 downto 0) <= s_int(1 downto 0) ;

	-- concurrent statements
	ts(0) <= (en and (not sclr)) or (sclr and s_int(0)) ;
	ts(1) <= (en and (not sclr) and s_int(0)) or (sclr and s_int(1)) ;
	ripple <= en and s_int(0) and s_int(1) ;

	-- sequential statements
	process (clk, rst) begin
		if rst = '1' then
			s_int(1 downto 0) <= "00" ;
		elsif clk'event and clk = '1' then
			s_int(1 downto 0) <= ((not ts(1 downto 0)) and s_int(1 downto 0)) or (ts(1 downto 0) and (not s_int(1 downto 0))) ;
		end if ;
	end process ;

end synthesis;
