library IEEE;
library UNISIM;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity count4Z is
	port (
		clk : in std_logic ;
		rst : in std_logic ;
		en : in std_logic ;
		sclr : in std_logic ;
		s : out std_logic_vector (3 downto 0) ;
		ripple : out std_logic
	);
end count4Z;

architecture synthesis of count4Z is

	-- submodules declarations
	component count2Z
		port (
			clk : in std_logic ;
			rst : in std_logic ;
			en : in std_logic ;
			sclr : in std_logic ;
			s : out std_logic_vector (1 downto 0) ;
			ripple : out std_logic
		) ;
	end component ;

	-- buffer signals declarations
	signal s_int : std_logic_vector (3 downto 0) ;

	-- internal signals declarations
	signal rip1 : std_logic ;

begin

	-- buffer signals assignations
	s(3 downto 0) <= s_int(3 downto 0) ;

	-- components instanciations
	count2Z_0 : count2Z port map (clk, rst, en, sclr, s_int(1 downto 0), rip1) ;
	count2Z_1 : count2Z port map (clk, rst, rip1, sclr, s_int(3 downto 2), ripple) ;

end synthesis;
